/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of LibUUID.xs. Do not edit this file, edit LibUUID.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "LibUUID.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define NEED_load_module
#define NEED_vload_module
#define NEED_sv_2pv_flags
#include "ppport.h"

#include <uuid/uuid.h>

#define UUID_TYPE_DCE 2
#define UUID_TYPE_TIME 1
#define UUID_TYPE_RANDOM 4

#define UUID_HEX_SIZE sizeof(uuid_t) * 2
#define UUID_STRING_SIZE 36
#define UUID_BASE64_SIZE 24
#define UUID_BASE64_LF_SIZE 25
#define UUID_BASE64_CRLF_SIZE 26


/* these define RETBUF, which is the PV inside RETVAL preallocated to a certain
 * size. Avoids the copying of XSRETURN_PVN and teaches me to write more
 * obfuscated C ;-) */

/* type bufer[size] with SvCUR set to cur */
#define dRETBUF(type, size, cur) \
    type RETBUF; \
    RETVAL = newSV(size); \
    SvPOK_on(RETVAL); \
    SvCUR_set(RETVAL, cur); \
    RETBUF = (type)SvPVX(RETVAL)

/* sizeof(type) buffer with SvCUR set to size */
#define dRETBUFs(type, size) dRETBUF(type, size, size)

/* null terminated buffer with size + 1 bytes and SvCUR set to size */
#define dRETBUFz(size) \
    dRETBUF(char *, size + 1, size); \
    RETBUF[size + 1] = 0

#define dUUIDRETBUF dRETBUFs(unsigned char *, sizeof(uuid_t))
#define dSTRRETBUF  dRETBUFs(char *, UUID_STRING_SIZE)
#define dHEXRETBUF  dRETBUFz(UUID_HEX_SIZE)

/* FIXME uuid_time, uuid_type, uuid_variant are available in libuuid but not in
 * darwin's uuid.h... consider exposing? */

/* generates a new UUID of a given version */
STATIC void new_uuid (IV version, uuid_t uuid) {
    switch (version) {
        case UUID_TYPE_TIME:
            uuid_generate_time(uuid);
            break;
        case UUID_TYPE_RANDOM:
            uuid_generate_random(uuid);
            break;
        case UUID_TYPE_DCE:
        default:
            uuid_generate(uuid);
    }
}

STATIC IV hex_to_uuid (uuid_t uuid, char *pv) {
    int i;

    Zero(uuid, 1, uuid_t);

    /* decode hex */
    for ( i = 0; i < sizeof(uuid_t); i++ ) {
        if ( !isALNUM(*pv) )
            return 0;
    }

    for ( i = 0; i < sizeof(uuid_t); i++ ) {
        /* left nybble */
        if ( isDIGIT(*pv) )
            uuid[i] |= ( *pv++ << 4 ) & 0xf0;
        else
            uuid[i] |= ( (*pv++ + 9) << 4 ) & 0xf0;

        /* right nybble */
        if ( isDIGIT(*pv) )
            uuid[i] |= *pv++ & 0xf;
        else
            uuid[i] |= (*pv++ + 9) & 0xf;

    }

    return 1;
}

/* hex-string, hex, base64 (TODO), or binary sv to uuid_t */
STATIC IV sv_to_uuid (SV *sv, uuid_t uuid) {
    dSP;

    if ( SvPOK(sv) || sv_isobject(sv) ) {
        char *pv;
        STRLEN len;

        if ( SvPOK(sv) ) {
            pv = SvPV_nolen(sv);
            len = SvCUR(sv);
        } else {
            pv = SvPV(sv, len);
        }

        switch ( len ) {
            case UUID_HEX_SIZE:
                return hex_to_uuid(uuid, pv);
            case UUID_BASE64_SIZE:
            case UUID_BASE64_LF_SIZE:
            case UUID_BASE64_CRLF_SIZE:

                load_module(PERL_LOADMOD_NOIMPORT, newSVpvs("MIME::Base64"), NULL);

                PUSHMARK(SP);
                XPUSHs(sv);
                PUTBACK;

                call_pv("MIME::Base64::decode_base64", G_SCALAR);

                SPAGAIN;
                pv = SvPV_nolen(TOPs);

                /* fall through */
            case sizeof(uuid_t):
                uuid_copy(uuid, *(uuid_t *)pv);
                return 1;
            case UUID_STRING_SIZE:
                if ( uuid_parse(pv, uuid) == 0 )
                    return 1;
        }
    }

    return 0;
}


#line 151 "LibUUID.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 194 "LibUUID.c"

XS(XS_Data__UUID__LibUUID_uuid_eq); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_uuid_eq)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "uu1_sv, uu2_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	uu1_sv = ST(0);
	SV *	uu2_sv = ST(1);
#line 150 "LibUUID.xs"
        uuid_t uu1;
        uuid_t uu2;
#line 214 "LibUUID.c"
	SV *	RETVAL;
#line 153 "LibUUID.xs"
        if ( sv_to_uuid(uu1_sv, uu1) && sv_to_uuid(uu2_sv, uu2) )
            if ( uuid_compare(uu1, uu2) == 0 )
                XSRETURN_YES;
            else
                XSRETURN_NO;
        else
            XSRETURN_UNDEF;
#line 224 "LibUUID.c"
	PUTBACK;
	return;
    }
}


XS(XS_Data__UUID__LibUUID_uuid_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_uuid_compare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "uu1_sv, uu2_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	uu1_sv = ST(0);
	SV *	uu2_sv = ST(1);
#line 167 "LibUUID.xs"
        uuid_t uu1;
        uuid_t uu2;
#line 249 "LibUUID.c"
	SV *	RETVAL;
#line 170 "LibUUID.xs"
        if ( sv_to_uuid(uu1_sv, uu1) && sv_to_uuid(uu2_sv, uu2) )
            XSRETURN_IV(uuid_compare(uu1, uu2));
        else
            XSRETURN_UNDEF;
#line 256 "LibUUID.c"
	PUTBACK;
	return;
    }
}


XS(XS_Data__UUID__LibUUID_new_uuid_binary); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_new_uuid_binary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 179 "LibUUID.xs"
        IV version = UUID_TYPE_DCE;
#line 275 "LibUUID.c"
	SV *	RETVAL;
#line 181 "LibUUID.xs"
        dUUIDRETBUF;

        if ( items == 1 ) version = SvIV(ST(0));

        new_uuid(version, RETBUF);
#line 283 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_new_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_new_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 192 "LibUUID.xs"
        uuid_t uuid;
        IV version = UUID_TYPE_DCE;
#line 304 "LibUUID.c"
	SV *	RETVAL;
#line 195 "LibUUID.xs"
        dSTRRETBUF;

        if ( items == 1 ) version = SvIV(ST(0));

        new_uuid(version, uuid);
        uuid_unparse(uuid, RETBUF);
#line 313 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_uuid_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_uuid_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 208 "LibUUID.xs"
        uuid_t uuid;
#line 335 "LibUUID.c"
	SV *	RETVAL;
#line 210 "LibUUID.xs"
        if ( sv_to_uuid(sv, uuid) ) {
            dSTRRETBUF;
            uuid_unparse(uuid, RETBUF);
        } else
            XSRETURN_UNDEF;
#line 343 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_uuid_to_binary); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_uuid_to_binary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
	SV *	RETVAL;
#line 222 "LibUUID.xs"
        dUUIDRETBUF;
        if ( !sv_to_uuid(sv, RETBUF) )
            XSRETURN_UNDEF;
#line 368 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_uuid_to_hex); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_uuid_to_hex)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 232 "LibUUID.xs"
        uuid_t uuid;
#line 390 "LibUUID.c"
	SV *	RETVAL;
#line 234 "LibUUID.xs"
        if ( sv_to_uuid(sv, uuid) ) {
            int i;
            U8 bits = 0;
            U8 *uuid_ptr = (U8 *)uuid;
            dHEXRETBUF;

            for (i = 0; i < UUID_HEX_SIZE; i++) {
                if (i & 1) bits <<= 4;
                else bits = *uuid_ptr++;
                RETBUF[i] = PL_hexdigit[(bits >> 4) & 15];
            }
        } else XSRETURN_UNDEF;
#line 405 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_new_dce_uuid_binary); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_new_dce_uuid_binary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
#line 251 "LibUUID.xs"
        dUUIDRETBUF;
        uuid_generate(RETBUF);
#line 427 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Data__UUID__LibUUID_new_dce_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Data__UUID__LibUUID_new_dce_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 258 "LibUUID.xs"
        uuid_t uuid;
#line 447 "LibUUID.c"
	SV *	RETVAL;
#line 260 "LibUUID.xs"
        dSTRRETBUF;
        uuid_generate(uuid);
        uuid_unparse(uuid, RETBUF);
#line 453 "LibUUID.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Data__UUID__LibUUID); /* prototype to pass -Wmissing-prototypes */
XS(boot_Data__UUID__LibUUID)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Data::UUID::LibUUID::uuid_eq", XS_Data__UUID__LibUUID_uuid_eq, file, "$$");
        newXSproto("Data::UUID::LibUUID::uuid_compare", XS_Data__UUID__LibUUID_uuid_compare, file, "$$");
        newXSproto("Data::UUID::LibUUID::new_uuid_binary", XS_Data__UUID__LibUUID_new_uuid_binary, file, ";$");
        newXSproto("Data::UUID::LibUUID::new_uuid_string", XS_Data__UUID__LibUUID_new_uuid_string, file, ";$");
        newXSproto("Data::UUID::LibUUID::uuid_to_string", XS_Data__UUID__LibUUID_uuid_to_string, file, "$");
        newXSproto("Data::UUID::LibUUID::uuid_to_binary", XS_Data__UUID__LibUUID_uuid_to_binary, file, "$");
        newXSproto("Data::UUID::LibUUID::uuid_to_hex", XS_Data__UUID__LibUUID_uuid_to_hex, file, "$");
        newXSproto("Data::UUID::LibUUID::new_dce_uuid_binary", XS_Data__UUID__LibUUID_new_dce_uuid_binary, file, ";@");
        newXSproto("Data::UUID::LibUUID::new_dce_uuid_string", XS_Data__UUID__LibUUID_new_dce_uuid_string, file, ";@");
    XSRETURN_YES;
}

